package org.ballerinalang.stdlib.builtin.generated.providers;

import org.ballerinalang.annotation.JavaSPIService;
import org.ballerinalang.model.types.TypeKind;
import org.ballerinalang.natives.NativeElementRepository;
import org.ballerinalang.natives.NativeElementRepository.NativeActionDef;
import org.ballerinalang.natives.NativeElementRepository.NativeFunctionDef;
import org.ballerinalang.spi.NativeElementProvider;

@JavaSPIService ("org.ballerinalang.spi.NativeElementProvider")
public class StandardNativeElementProvider implements NativeElementProvider {

	@Override
	public void populateNatives(NativeElementRepository repo) {
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "string.replaceFirst", new TypeKind[] { TypeKind.STRING, TypeKind.STRING, TypeKind.STRING }, new TypeKind[] { TypeKind.STRING }, "org.ballerinalang.nativeimpl.builtin.stringlib.ReplaceFirst"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "string.lastIndexOf", new TypeKind[] { TypeKind.STRING, TypeKind.STRING }, new TypeKind[] { TypeKind.INT }, "org.ballerinalang.nativeimpl.builtin.stringlib.LastIndexOf"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "string.unescape", new TypeKind[] { TypeKind.STRING }, new TypeKind[] { TypeKind.STRING }, "org.ballerinalang.nativeimpl.builtin.stringlib.Unescape"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "string.contains", new TypeKind[] { TypeKind.STRING, TypeKind.STRING }, new TypeKind[] { TypeKind.BOOLEAN }, "org.ballerinalang.nativeimpl.builtin.stringlib.Contains"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "string.equalsIgnoreCase", new TypeKind[] { TypeKind.STRING }, new TypeKind[] { TypeKind.BOOLEAN }, "org.ballerinalang.nativeimpl.builtin.stringlib.EqualsIgnoreCase"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "string.toByteArray", new TypeKind[] { TypeKind.STRING, TypeKind.STRING }, new TypeKind[] { TypeKind.ARRAY }, "org.ballerinalang.nativeimpl.builtin.stringlib.ToByteArray"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "string.replace", new TypeKind[] { TypeKind.STRING, TypeKind.STRING, TypeKind.STRING }, new TypeKind[] { TypeKind.STRING }, "org.ballerinalang.nativeimpl.builtin.stringlib.Replace"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "string.split", new TypeKind[] { TypeKind.STRING, TypeKind.STRING }, new TypeKind[] { TypeKind.ARRAY }, "org.ballerinalang.nativeimpl.builtin.stringlib.Split"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "string.matches", new TypeKind[] { TypeKind.STRING, TypeKind.STRING }, new TypeKind[] { TypeKind.BOOLEAN, TypeKind.RECORD }, "org.ballerinalang.nativeimpl.builtin.stringlib.Matches"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "string.toUpper", new TypeKind[] { TypeKind.STRING }, new TypeKind[] { TypeKind.STRING }, "org.ballerinalang.nativeimpl.builtin.stringlib.ToUpper"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "string.indexOf", new TypeKind[] { TypeKind.STRING, TypeKind.STRING }, new TypeKind[] { TypeKind.INT }, "org.ballerinalang.nativeimpl.builtin.stringlib.IndexOf"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "string.toLower", new TypeKind[] { TypeKind.STRING }, new TypeKind[] { TypeKind.STRING }, "org.ballerinalang.nativeimpl.builtin.stringlib.ToLower"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "string.trim", new TypeKind[] { TypeKind.STRING }, new TypeKind[] { TypeKind.STRING }, "org.ballerinalang.nativeimpl.builtin.stringlib.Trim"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "string.hasPrefix", new TypeKind[] { TypeKind.STRING, TypeKind.STRING }, new TypeKind[] { TypeKind.BOOLEAN }, "org.ballerinalang.nativeimpl.builtin.stringlib.HasPrefix"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "string.findAll", new TypeKind[] { TypeKind.STRING, TypeKind.STRING }, new TypeKind[] { TypeKind.ARRAY, TypeKind.RECORD }, "org.ballerinalang.nativeimpl.builtin.stringlib.FindAll"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "string.length", new TypeKind[] { TypeKind.STRING }, new TypeKind[] { TypeKind.INT }, "org.ballerinalang.nativeimpl.builtin.stringlib.Length"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "string.replaceAll", new TypeKind[] { TypeKind.STRING, TypeKind.STRING, TypeKind.STRING }, new TypeKind[] { TypeKind.STRING }, "org.ballerinalang.nativeimpl.builtin.stringlib.ReplaceAll"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "string.substring", new TypeKind[] { TypeKind.STRING, TypeKind.INT, TypeKind.INT }, new TypeKind[] { TypeKind.STRING }, "org.ballerinalang.nativeimpl.builtin.stringlib.Substring"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "string.hasSuffix", new TypeKind[] { TypeKind.STRING, TypeKind.STRING }, new TypeKind[] { TypeKind.BOOLEAN }, "org.ballerinalang.nativeimpl.builtin.stringlib.HasSuffix"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "xml.removeAttribute", new TypeKind[] { TypeKind.STRING }, new TypeKind[] {  }, "org.ballerinalang.nativeimpl.builtin.xmllib.RemoveAttribute"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "xml.setChildren", new TypeKind[] { TypeKind.XML }, new TypeKind[] {  }, "org.ballerinalang.nativeimpl.builtin.xmllib.SetChildren"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "xml.selectDescendants", new TypeKind[] { TypeKind.STRING }, new TypeKind[] { TypeKind.XML }, "org.ballerinalang.nativeimpl.builtin.xmllib.SelectDescendants"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "xml.select", new TypeKind[] { TypeKind.STRING }, new TypeKind[] { TypeKind.XML }, "org.ballerinalang.nativeimpl.builtin.xmllib.Select"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "xml.toJSON", new TypeKind[] { TypeKind.RECORD }, new TypeKind[] { TypeKind.JSON }, "org.ballerinalang.nativeimpl.builtin.xmllib.ToJSON"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "xml.getElementName", new TypeKind[] {  }, new TypeKind[] { TypeKind.STRING }, "org.ballerinalang.nativeimpl.builtin.xmllib.GetElementName"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "xml.strip", new TypeKind[] {  }, new TypeKind[] { TypeKind.XML }, "org.ballerinalang.nativeimpl.builtin.xmllib.Strip"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "xml.slice", new TypeKind[] { TypeKind.INT, TypeKind.INT }, new TypeKind[] { TypeKind.XML }, "org.ballerinalang.nativeimpl.builtin.xmllib.Slice"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "xml.elements", new TypeKind[] {  }, new TypeKind[] { TypeKind.XML }, "org.ballerinalang.nativeimpl.builtin.xmllib.Elements"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "xml.removeChildren", new TypeKind[] { TypeKind.STRING }, new TypeKind[] {  }, "org.ballerinalang.nativeimpl.builtin.xmllib.RemoveChildren"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "xml.appendChildren", new TypeKind[] { TypeKind.XML }, new TypeKind[] {  }, "org.ballerinalang.nativeimpl.builtin.xmllib.AppendChildren"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "xml.getTextValue", new TypeKind[] {  }, new TypeKind[] { TypeKind.STRING }, "org.ballerinalang.nativeimpl.builtin.xmllib.GetTextValue"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "xml.copy", new TypeKind[] {  }, new TypeKind[] { TypeKind.XML }, "org.ballerinalang.nativeimpl.builtin.xmllib.Copy"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "xml.getItemType", new TypeKind[] {  }, new TypeKind[] { TypeKind.STRING }, "org.ballerinalang.nativeimpl.builtin.xmllib.GetItemType"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "xml.setAttributes", new TypeKind[] { TypeKind.MAP }, new TypeKind[] {  }, "org.ballerinalang.nativeimpl.builtin.xmllib.SetAttributes"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "xml.isEmpty", new TypeKind[] {  }, new TypeKind[] { TypeKind.BOOLEAN }, "org.ballerinalang.nativeimpl.builtin.xmllib.IsEmpty"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "xml.isSingleton", new TypeKind[] {  }, new TypeKind[] { TypeKind.BOOLEAN }, "org.ballerinalang.nativeimpl.builtin.xmllib.IsSingleton"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "table.add", new TypeKind[] { TypeKind.TABLE, TypeKind.ANY }, new TypeKind[] {  }, "org.ballerinalang.nativeimpl.builtin.tablelib.Add"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "table.hasNext", new TypeKind[] { TypeKind.TABLE }, new TypeKind[] { TypeKind.BOOLEAN }, "org.ballerinalang.nativeimpl.builtin.tablelib.HasNext"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "queryTableWithoutJoinClause", new TypeKind[] { TypeKind.STRING, TypeKind.TABLE, TypeKind.ARRAY, TypeKind.TYPEDESC }, new TypeKind[] { TypeKind.TABLE }, "org.ballerinalang.nativeimpl.builtin.tablelib.QueryTableWithoutJoinClause"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "queryTableWithJoinClause", new TypeKind[] { TypeKind.STRING, TypeKind.TABLE, TypeKind.TABLE, TypeKind.ARRAY, TypeKind.ANY }, new TypeKind[] { TypeKind.TABLE }, "org.ballerinalang.nativeimpl.builtin.tablelib.QueryTableWithJoinClause"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "table.remove", new TypeKind[] { TypeKind.TABLE, TypeKind.ANY }, new TypeKind[] {  }, "org.ballerinalang.nativeimpl.builtin.tablelib.Remove"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "table.close", new TypeKind[] { TypeKind.TABLE }, new TypeKind[] {  }, "org.ballerinalang.nativeimpl.builtin.tablelib.Close"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "table.getNext", new TypeKind[] { TypeKind.TABLE }, new TypeKind[] { TypeKind.ANY }, "org.ballerinalang.nativeimpl.builtin.tablelib.GetNext"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "future.cancel", new TypeKind[] { TypeKind.FUTURE }, new TypeKind[] { TypeKind.BOOLEAN }, "org.ballerinalang.nativeimpl.builtin.asynclib.Cancel"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "future.isCancelled", new TypeKind[] { TypeKind.FUTURE }, new TypeKind[] { TypeKind.BOOLEAN }, "org.ballerinalang.nativeimpl.builtin.asynclib.IsCancelled"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "future.isDone", new TypeKind[] { TypeKind.FUTURE }, new TypeKind[] { TypeKind.BOOLEAN }, "org.ballerinalang.nativeimpl.builtin.asynclib.IsDone"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "map.clear", new TypeKind[] { TypeKind.MAP }, new TypeKind[] {  }, "org.ballerinalang.nativeimpl.builtin.maplib.Clear"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "map.hasKey", new TypeKind[] { TypeKind.MAP, TypeKind.STRING }, new TypeKind[] { TypeKind.BOOLEAN }, "org.ballerinalang.nativeimpl.builtin.maplib.HasKey"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "map.remove", new TypeKind[] { TypeKind.MAP, TypeKind.STRING }, new TypeKind[] { TypeKind.BOOLEAN }, "org.ballerinalang.nativeimpl.builtin.maplib.Remove"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "map.values", new TypeKind[] { TypeKind.MAP }, new TypeKind[] { TypeKind.ARRAY }, "org.ballerinalang.nativeimpl.builtin.maplib.GetValues"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "map.keys", new TypeKind[] { TypeKind.MAP }, new TypeKind[] { TypeKind.ARRAY }, "org.ballerinalang.nativeimpl.builtin.maplib.GetKeys"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "startForever", new TypeKind[] { TypeKind.STRING, TypeKind.ARRAY, TypeKind.ARRAY, TypeKind.ARRAY, TypeKind.ARRAY, TypeKind.ARRAY }, new TypeKind[] { TypeKind.NONE }, "org.ballerinalang.nativeimpl.builtin.streamlib.StartForever"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "stream.publish", new TypeKind[] { TypeKind.STREAM, TypeKind.ANY }, new TypeKind[] {  }, "org.ballerinalang.nativeimpl.builtin.streamlib.Publish"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "stream.subscribe", new TypeKind[] { TypeKind.STREAM, TypeKind.ANY }, new TypeKind[] {  }, "org.ballerinalang.nativeimpl.builtin.streamlib.Subscribe"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "json.remove", new TypeKind[] { TypeKind.JSON, TypeKind.STRING }, new TypeKind[] {  }, "org.ballerinalang.nativeimpl.builtin.jsonlib.Remove"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "json.toXML", new TypeKind[] { TypeKind.JSON, TypeKind.RECORD }, new TypeKind[] { TypeKind.XML, TypeKind.RECORD }, "org.ballerinalang.nativeimpl.builtin.jsonlib.ToXML"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "json.getKeys", new TypeKind[] { TypeKind.JSON }, new TypeKind[] { TypeKind.ARRAY }, "org.ballerinalang.nativeimpl.builtin.jsonlib.GetKeys"));
		repo.registerNativeFunction(new NativeFunctionDef("ballerina", "builtin", "json.toString", new TypeKind[] { TypeKind.JSON }, new TypeKind[] { TypeKind.STRING }, "org.ballerinalang.nativeimpl.builtin.jsonlib.ToString"));
	}

}
